<?php
include './secret.php';

/*
 * Вспомогательный класс для обращения к REST Б24.
 */
class BX24
{

	public $app_token = '';
	public $domain = '';
	public $lang = '';
	protected $access_token = '';
	protected $refresh_token = '';
	private $error = '';
	private $client_id = B24_CLIENT_ID;
	private $client_seecret = B24_CLIENT_SECRET;
	private $config_path = '/auth/';
	private $chat_path = '/auth/chat/';

	/*
	 * Сохраняет ID чатов бота.
	 */
	public function saveChatId($chatId)
	{
		file_put_contents($_SERVER['DOCUMENT_ROOT'].$this->chat_path.$this->app_token.'_'.$chatId, '');
	}

	/*
	 * Сохраняем актуальные токены.
	 */
	public function saveParams($file, $params)
	{
		file_put_contents($_SERVER['DOCUMENT_ROOT'].$this->config_path.$file, serialize($params));
	}

	/*
	 * Удаление токенов.
	 */
	public static function deleteParams($file)
	{
		$file = $_SERVER['DOCUMENT_ROOT'].self::$config_path.$file;
		if (file_exists($file)) {
			unlink($file);
		}
	}

	/*
	 * Конструктор класса.
	 */
	public function __construct($file, $params = false) {
		if ($params !== false) {
			$this->saveParams($file, $params);
		}
		if ($params = unserialize(file_get_contents($_SERVER['DOCUMENT_ROOT'].'/auth/'.$file))) {
			$this->domain = $params['domain'];
			$this->app_token = $file;
			$this->access_token = $params['access_token'];
			$this->refresh_token = $params['refresh_token'];
		}
	}

	/*
	 * Для логирования запросов.
	 */
	public function log($arFields) {
		if (function_exists('AddMessage2Log')) {
			AddMessage2Log(print_r($arFields, true).' (domain: '.$this->domain.')');
		}
	}

	/*
	 * А вот это уже использует CURL для отправки методом POST. Если сервер не поддерживает оное,
	 * надо либо сделать поддержку, либо переписать по иному отправку POST.
	 */
	public function postCommand($rest, $arFields=array(), $orig=false) {
		$arFields['auth'] = $this->access_token;
		$url = 'https://'.$this->domain.'/rest/'.$rest;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_VERBOSE, 1);
		//curl_setopt($ch, CURLOPT_USERAGENT, 'CMS Connector');
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($arFields));
		$response = curl_exec($ch);
		curl_close($ch);
		if ($orig) {
			if ($arData = json_decode($response, true)) {
				$this->MakeError($arData, $rest);
			}
			return $response;
		} elseif ($arData = json_decode($response, true)) {
			//обновляем токен, если он истек, и повторяем запрос
			if (isset($arData['error']) && ($arData['error']=='expired_token' || $arData['error']=='invalid_token')) {
				$params = array(
					'grant_type' => 'refresh_token',
					'client_id' => $this->client_id,
					'client_secret' => $this->client_seecret,
					'refresh_token' => $this->refresh_token,
				);
				$url = 'https://'.$this->domain.'/oauth/token/?'.http_build_query($params);
				$data = file_get_contents($url);
				if ($arData = json_decode($data, true)) {
					if (!isset($arData['error'])) {
						$this->saveParams($this->app_token, serialize($arData));
						return $this->postCommand($rest, $arFields);
					}
				}
			}
			if ($this->MakeError($arData, $rest)) {
				return false;
			} else {
				return $arData;
			}
		} else {
			return false;
		}
	}

	/*
	 * Обработка ошибки.
	 */
	private function MakeError($arData, $rest) {
		$this->error = '';
		if (isset($arData['error']) && (strlen($arData['error']) || strlen($arData['error_description']))) {
			if (isset($arData['error_description'])) {
				$this->error = $arData['error_description'];
			}
			if (!strlen($this->error)) {
				$this->error = $arData['error'];
			}
			if (strpos($this->error, 'The access token provided has expired') !== false) {
				$this->error .= ' Please refresh page.';
			}
			$this->error = strip_tags($this->error);
			$this->error = str_replace(array('&quot;'), array('"'), $this->error);
			if (strlen($this->error)) {
				$this->Log($this->error.' ('.$rest.')');
			}
			return true;
		} else {
			return false;
		}
	}

	/*
	 * Вывод ошибки.
	 */
	public function GetError() {
		return $this->error;
	}
}